"use strict";
var strings_1 = require("./strings");
function mapperCacheRelationByField(mapper) {
    if (!mapper.relationByField || !mapper.relationByFieldId) {
        mapper.relationByField = {};
        mapper.relationByFieldId = {};
        for (var i = 0, l = (mapper.relationList || []).length; i < l; i++) {
            var field = mapper.relationList[i].localField;
            if (mapper.relationList[i].type === 'belongsTo') {
                var key = mapper.relationList[i].foreignKey;
                if (!mapper.relationList[i].foreignKey) {
                    this.warn(strings_1.WARNING.NO_FOREIGN_KEY, mapper.relationList[i]);
                }
                else {
                    mapper.relationByFieldId[key] = mapper.relationList[i];
                }
            }
            if (field) {
                mapper.relationByField[field] = mapper.relationList[i];
            }
            else {
                this.warn('localField missing');
                continue;
            }
        }
    }
}
exports.mapperCacheRelationByField = mapperCacheRelationByField;
//# sourceMappingURL=utils.js.map